function LaunchTACCredits()
{
   Canvas.setContent(TACCreditsGui);
}

function cancelTACCredits()
{
   //delete the action map
   TACCreditsActionMap.pop();

   //kill the schedules
   cancel($TACCreditsScrollSchedule);
   cancel($TACCreditsSlideShow);

   //kill the music
   MusicPlayer.stop();

   //load the launch gui back...
   Canvas.setContent(LaunchGui);

   //delete the contents of the ML ctrl so as to free up memory...
   TACCredits_Text.setText("");
}

function TACCreditsGui::onWake(%this)
{
   //create an action map to use "esc" to exit the TACCredits screen...
   if (!isObject(TACCreditsActionMap))
   {
      new ActionMap(TACCreditsActionMap);
      TACCreditsActionMap.bindCmd(keyboard, anykey, "cancelTACCredits();", "");
      TACCreditsActionMap.bindCmd(keyboard, space, "cancelTACCredits();", "");
      TACCreditsActionMap.bindCmd(keyboard, escape, "cancelTACCredits();", "");
      TACCreditsActionMap.bindCmd(mouse, button0, "$TACCreditsPaused = true;", "$TACCreditsPaused = false;");
      TACCreditsActionMap.bindCmd(mouse, button1, "$TACCreditsSpeedUp = true;", "$TACCreditsSpeedUp = false;");
      TACCreditsActionMap.bindCmd(mouse, button2, "TACCreditsNextPic();", "");
   }
   TACCreditsActionMap.push();

   //build the ML text ctrl...
   exec("scripts/TACCreditsText.cs");

   $TACCreditsPicIndex = 1;
   if(isfile("textures/gui/tac_Cred_" @ $TACCreditsPicIndex @ ".png"))
   		TACCredits_Pic.setBitmap("gui/tac_Cred_" @ $TACCreditsPicIndex @ ".png");
   else
   		TACCredits_Pic.setBitmap("gui/Cred_" @ $TACCreditsPicIndex @ ".png");

   //music array
   $TACCreditsMusic[0] = "badlands";
   $TACCreditsMusic[1] = "desert";
   $TACCreditsMusic[2] = "ice";
   $TACCreditsMusic[3] = "lush";
   $TACCreditsMusic[4] = "volcanic";

   //start the TACCredits from the beginning
   $TACCreditsOffset = 0.0;
   %screenHeight = getWord(getResolution(), 1);
   TACCredits_Text.resize(getWord(TACCredits_Text.position, 0),
                        mFloor(%screenHeight / 2) - 125,
                        getWord(TACCredits_Text.extent, 0),
                        getWord(TACCredits_Text.extent, 1));

   //start the scrolling
   $TACCreditsPaused = false;
   $TACCreditsSpeedUp = false;
   $TACCreditsScrollSchedule = schedule(3000, 0, scrollTheTACCredits);

   //start cycling the bitmaps
   $TACCreditsSlideShow = schedule(5000, 0, TACCreditsNextPic);

   //start some music
   %chooseTrack = mFloor(getRandom() * 4.99);
   MusicPlayer.playTrack($TACCreditsMusic[%chooseTrack]);
}

function checkPureMapFile(%mapname)
{
	return true;
}

function addTACCreditsLine(%text, %lastLine)
{
   TACCredits_Text.addText(%text @ "\n", %lastline);
}

function scrollTheTACCredits()
{
   //make sure we're not paused
   if (!$TACCreditsPaused)
   {
      //if we've scrolled off the top, set the position back down to the bottom
      %parentCtrl = TACCredits_Text.getGroup();
      if (getWord(TACCredits_Text.position, 1) + getWord(TACCredits_Text.extent, 1) < 0)
      {
         TACCredits_Text.position = getWord(TACCredits_Text.position, 0) SPC getWord(%parentCtrl.extent, 1);
         $TACCreditsOffset = getWord(TACCredits_Text.position, 1);
      }

      if ($TACCreditsSpeedUp)
         %valueToScroll = 10;
      else
         %valueToScroll = 1;

      //scroll the control up a bit
      TACCredits_Text.resize(getWord(TACCredits_Text.position, 0),
                           getWord(TACCredits_Text.position, 1) - %valueToScroll,
                           getWord(TACCredits_Text.extent, 0),
                           getWord(TACCredits_Text.extent, 1));
   }

   //schedule the next scroll...
   $TACCreditsScrollSchedule = schedule(10, 0, scrollTheTACCredits);
}

$TAC::CreditsLoaded = true;

function TACCreditsNextPic()
{
   cancel($TACCreditsSlideShow);
   if (!$TACCreditsPaused)
   {
      $TACCreditsPicIndex += 1;
      if ($TACCreditsPicIndex > 46)
         $TACCreditsPicindex = 1;

      //set the bitmap
      if(isfile("textures/gui/tac_Cred_" @ $TACCreditsPicIndex @ ".png"))
      {
      		TACCredits_Pic.setBitmap("gui/tac_Cred_" @ $TACCreditsPicIndex @ ".png");
	  }
      else
      {
      		TACCredits_Pic.setBitmap("gui/Cred_" @ $TACCreditsPicIndex @ ".png");
	  }
   }

   //schedule the next bitmap
   $TACCreditsSlideShow = schedule(5000, 0, TACCreditsNextPic);
}

