//Major overhaul and update 19-03-03 SaNTa
//=====================================================================================
//	TAC2 - TDM Mission Code									Wizard_TPG - 11/5/2001
//                                                          Crazy in here as well SaNTa :)
//	This code includes:
//				Basic TDM Game Code
//
//=====================================================================================


//exec the AI scripts
//exec("scripts/aiCTF.cs");

//-- tracking  ---         moved up to here SaNTa 19-03-03
// .deaths .kills .genDefends .carrierKills .flagDefends .escortAssists .suicides .teamKills .turretKills .flagCaps
// .flagReturns .genDestroys .genRepairs

function TAC_TDMGame::initGameVars(%game)
{
	%game.SCORE_PER_VEHICLE_APC_KILL = 50;  	//enemy team gets this for killing your apc from a vehicle
	%game.SCORE_PER_OTHER_APC_KILL = 0;		//enemy team gets this for killing apc otherwise
	%game.SCORE_PER_OWN_APC_KILL = -50;		//Your team gets this if you tk an apc
	%game.SCORE_PER_BASE_APC_KILL = 0;		//Enemy team gets this if your veihcle is destroyed by enemy base turrets
	%game.SCORE_PER_TURRET_APC_KILL = 0;	//Enemy team gets this for kills by other turrets
	%game.SCORE_PER_CRASH_APC_KILL = -50;	//Your team gets this if you crash an apc
	%game.SCORE_PER_COLLIDE_APC_KILL = 50;	//Your team gets this if you collide with an enemy causing their vehicle to be destroyed
	%game.SCORE_DEDUCTION_NO_VEHICLE_INFIELD = -1;  //The amount that gets deducted per second that a manned vehicle is not in playing field

	%game.SCORE_PER_SUICIDE = 0;
	%game.SCORE_PER_TEAMKILL = 0;
	%game.SCORE_PER_DEATH = 0;

	%game.SCORE_PER_KILL = 0;
	%game.SCORE_PER_PLYR_FLAG_CAP = 0;
	%game.SCORE_PER_TEAM_FLAG_CAP = 0;
	%game.SCORE_PER_GEN_DESTROY = 0;
	%game.SCORE_PER_ESCORT_ASSIST = 0;

	%game.SCORE_PER_TURRET_KILL = 0;
	%game.SCORE_PER_FLAG_DEFEND = 0;
	%game.SCORE_PER_CARRIER_KILL = 0;
	%game.SCORE_PER_FLAG_RETURN = 0;
	%game.SCORE_PER_GEN_DEFEND = 0;
	%game.SCORE_PER_GEN_REPAIR = 0;

	%game.FLAG_RETURN_DELAY = 15 * 1000;

	%game.TIME_CONSIDERED_FLAGCARRIER_THREAT = 0;  //after damaging enemy flag carrier
	%game.RADIUS_GEN_DEFENSE = 0;  //meters
	%game.RADIUS_FLAG_DEFENSE = 0;  //meters

	%game.fadeTimeMS = 2000;
	%game.notifyMineDist = 7.5;
}



package TAC_TDMGame
{
	//Remove Hawkeye and MPB from invs in TDM
	function StationVehiclePad::onAdd(%this, %obj)
	{
	   	Parent::onAdd(%this, %obj);

		%sv = %obj.station;
		%sv.vehicle[TACMobileBaseVehicle] = false;
		%sv.vehicle[TACScoutFlyer] = false;
	}
 
      // Function added and modified SaNTa 19-03-03
   function ShapeBaseData::onDestroyed(%data, %obj)
{
         // SaNTa 19-03-03
}

//added 19-03-03 SaNTa
   function ShapeBaseData::onDisabled(%data, %obj)
     {
     %obj.wasDisabled = true;
     Parent::onDisabled(%data, %obj);
     }
     //added 19-03-03 SaNTa
     function RepairGunImage::onRepair(%this, %obj, %slot)
     {
     Parent::onRepair(%this, %obj, %slot);
     %target = %obj.repairing;
     if(%target && %target.team != %obj.team)
         {
        //error("Enemy stuff("@%obj@") is being repaired (by "@%target@")");
        %target.soiledByEnemyRepair = true;
         }
     }
 
 
};




//--------------------------------------------------------------------------------------------------------------------

function TAC_TDMGame::missionLoadDone(%game)
{
	%game.numTeams = 2;

   //continue with the default function
   DefaultGame::missionLoadDone(%game);
}

function TAC_TDMGame::setUpTeams(%game)
{
   DefaultGame::setUpTeams(%game);
   %game.numTeams = 2;
   setSensorGroupCount(%game.numTeams + 1);
   %game.TDMTeam1PointCheck = %game.schedule(1000, "TDMTeamPointCheck", 1);
   %game.TDMTeam2PointCheck = %game.schedule(1000, "TDMTeamPointCheck", 2);
    %game.Base1Defence = %game.schedule(10000, "BaseDefence", 1);  // New Base Defence SaNTa
    %game.Base2Defence = %game.schedule(10000, "BaseDefence", 2);
//    $TeamScore[1] = 0;    // This makes sure the team score is zero next mission because of delayed vehicle crashes SaNta 23-03-03
//    $TeamScore[2] = 0;    // This makes sure the team score is zero next mission because of delayed vehicle crashes SaNta 23-03-03
   for(%i = 0; %i <= %game.numTeams; %i++)
		$TeamScore[%i] = 0;

   error("LOG: Team Scores Cleared for TDM Game");
}


function TAC_TDMGame::equip(%game, %player)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);

   %player.setInventory(RepairKit,1);
   %player.setInventory(FlareGrenade,6);
   %player.setInventory(Blaster,1);
   %player.setInventory(Chaingun,1);
   %player.setInventory(ChaingunAmmo, 100);
   %player.setInventory(Disc,1);
   %player.setInventory(DiscAmmo, 20);
   %player.setInventory(RepairPack,1);
   %player.setInventory(TargetingLaser, 1);
   %player.weaponCount = 3;
   %player.use("RepairPack");
}

function TAC_TDMGame::VehicleKill(%game, %data, %obj)
{
	DefaultGame::VehicleKill(%game, %data, %obj);
}

function TAC_TDMGame::timeLimitReached(%game)
{
	echo("LOG: game over (timelimit)");
	%game.gameOver();
   schedule( 5000, %game, cycleMissions );
}

function TAC_TDMGame::scoreLimitReached(%game)
{
	echo("LOG: game over (scorelimit)");
	%game.gameOver();
   schedule( 5000, %game, cycleMissions );
}

function TAC_TDMGame::gameOver(%game)
{
	//send the winner message
	%winner = "";
	if ($teamScore[1] > $teamScore[2])
		%winner = $teamName[1];
	else if ($teamScore[2] > $teamScore[1])
		%winner = $teamName[2];

	if (%winner $= 'Storm')
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.stowins.wav" );
	else if (%winner $= 'Inferno')
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.infwins.wav" );
	else
	   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );

	//call the default
	DefaultGame::gameOver(%game);

   %game.sendDebriefing();
	messageAll('MsgClearObjHud', "");
	for(%i = 0; %i < ClientGroup.getCount(); %i ++)
	{
		%client = ClientGroup.getObject(%i);
		%game.resetScore(%client);
	}
   for(%j = 1; %j <= %game.numTeams; %j++)
		$TeamScore[%j] = 0;
}


////////////////////////////////////////////////////////////////////////////////////////
function TAC_TDMGame::clientMissionDropReady(%game, %client)
{
   	messageClient(%client, 'MsgClientReady',"", %game.class);
   	for(%i = 1; %i <= %game.numTeams; %i++)
   	{
      	messageClient(%client, 'MsgTDMAddTeam', "", %i, $TeamName[%i], $TeamScore[%i]);
   	}

	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );

	DefaultGame::clientMissionDropReady(%game, %client);
}


function TAC_TDMGame::assignClientTeam(%game, %client, %respawn)
{
	DefaultGame::assignClientTeam(%game, %client, %respawn);
	// if player's team is not on top of objective hud, switch lines
	messageClient(%client, 'MsgCheckTeamLines', "", %client.team);
}

function TAC_TDMGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement)
{
	if(%clKiller <= 0 || %clKiller $= "")
	{
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testKill(%clVictim, %clKiller)) //verify victim was an enemy
	{
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else
	{
		if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		{
			%game.awardScoreSuicide(%clVictim);
		}
		else
		{
			if (%game.testTeamKill(%clVictim, %clKiller)) //otherwise test for a teamkill
				%game.awardScoreTeamKill(%clVictim, %clKiller);
		}
	}
}

function TAC_TDMGame::TDMTeamPointCheck(%game, %team)
{
	if(%team == 1)
		cancel(%game.TDMTeam1PointCheck);
	else
		cancel(%game.TDMTeam2PointCheck);

	//Does this team have a client in a vehicle in the mission area?
	%foundvehicle = false;
	for(%i = 0; %i < ClientGroup.getCount(); %i ++)
	{
		%client = ClientGroup.getObject(%i);
		if(%client.team == %team && !%client.outOfBounds)
		{
			%player = %client.player;
			%vehicle = %player.lastVehicle;
			if(isObject(%vehicle))
				%foundvehicle = true;
		}
		if(%foundvehicle)
			%i = ClientGroup.getCount();
	}

	if($TeamScore[%team] > 0 && !%foundvehicle)
	{
		%deduction = %game.SCORE_DEDUCTION_NO_VEHICLE_INFIELD !$= "" ? %game.SCORE_DEDUCTION_NO_VEHICLE_INFIELD : 0;
		$TeamScore[%team] += %deduction;
		%enemyteam = %team == 1 ? 2 : 1;
		%points = %deduction * -1;
		%plural = %points > 1 ? "s" : "";
		if(%game.firstPointLossMessage)
		{
			messageTeam(%team, 'MsgTACTDMPointsLoss', '\c0Your team is losing points because there is no mounted vehicle in the mission area!~wfx/misc/TDM_Losing_Points_Alarm.wav', $TeamScore[%team], %team);
			messageTeam(%enemyteam, 'MsgTACTDMPointsLoss', '\c0Enemy team is losing points for having no mounted vehicle in the mission area!', $TeamScore[%team], %team);
			messageTeam(0, 'MsgTACTDMPointsLoss', '\c0 %3 is losing points for having no mounted vehicle in the mission area!', $TeamScore[%team], %team, $TeamName[%team]);
		}
		else
		{
			messageTeam(%team, 'MsgTACTDMPointsLoss', "", $TeamScore[%team], %team);
			messageTeam(%enemyteam, 'MsgTACTDMPointsLoss', "", $TeamScore[%team], %team);
			messageTeam(0, 'MsgTACTDMPointsLoss', "", $TeamScore[%team], %team);
		}
		%game.checkScoreLimit(%team);
	}

	if(%team == 1)
	  	%game.TDMTeam1PointCheck = %game.schedule(1000, "TDMTeamPointCheck", 1);
	else
   		%game.TDMTeam2PointCheck = %game.schedule(1000, "TDMTeamPointCheck", 2);
}

function TAC_TDMGame::checkScoreLimit(%game, %team)
{
	%scoreLimit = MissionGroup.TAC_TDM_scoreLimit;
	// default of 50 if scoreLimit not defined
	if(%scoreLimit $= "")
		%scoreLimit = 500;
   if($TeamScore[%team] >= %scoreLimit)
      %game.scoreLimitReached();
}

function TAC_TDMGame::enterMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
	return;

   	%player.client.outOfBounds = false;
   	messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
	//the instant a player leaves the mission boundary, the flag is dropped, and the return is scheduled...
	if (%player.holdingFlag > 0)
	{
		cancel($FlagReturnTimer[%player.holdingFlag]);
		$FlagReturnTimer[%player.holdingFlag] = "";
	}
}

function TAC_TDMGame::leaveMissionArea(%game, %playerData, %player)
{
	if(%player.getState() $= "Dead")
	return;

	// maybe we'll do this just in case
   	%player.client.outOfBounds = true;
	// if the player is holding a flag, strip it and throw it back into the mission area
	// otherwise, just print a message
	if(%player.holdingFlag > 0)
		%game.boundaryLoseFlag(%player);
	else
      messageClient(%player.client, 'MsgLeaveMissionArea', '\c1You have left the mission area.');
	echo("LOG: "@%player@" ("@%player.client@") leave mission area");
}

function TAC_TDMGame::applyConcussion(%game, %player)
{
//   %game.dropFlag( %player );  SaNTa 19-03-03
}

function TAC_TDMGame::onClientDamaged(%game, %clVictim, %clAttacker, %damageType, %implement, %damageLoc)
{
   //SaNTa 19-03-03
}
//Added SaNTa 19-03-03
function TAC_TDMGame::resetScore(%game, %client)
{
    DefaultGame::resetScore(%game, %client); //ZENGEI - Just fixing some bugs :P - June 24, 2006
//   %client.offenseScore = 0;
   %client.kills = 0;
   %client.deaths = 0;
   %client.suicides = 0;
//   %client.escortAssists = 0;
   %client.teamKills = 0;
//   %client.flagCaps = 0;
//   %client.flagGrabs = 0;
//   %client.genDestroys = 0;
//   %client.sensorDestroys = 0;
//   %client.turretDestroys = 0;
//   %client.iStationDestroys = 0;
//   %client.vstationDestroys = 0;
//   %client.solarDestroys = 0;
//   %client.sentryDestroys = 0;
//   %client.depSensorDestroys = 0;
//   %client.depTurretDestroys = 0;
//   %client.depStationDestroys = 0;
   %client.vehicleScore = 0;
   %client.vehicleBonus = 0;

//    %client.flagDefends = 0;
//   %client.defenseScore = 0;
//   %client.genDefends = 0;
//   %client.carrierKills = 0;
//   %client.escortAssists = 0;
//   %client.turretKills = 0;
//   %client.mannedTurretKills = 0;
//   %client.flagReturns = 0;
//   %client.genRepairs = 0;
//    %client.SensorRepairs   =0;
//    %client.TurretRepairs   =0;
//    %client.StationRepairs  =0;
//    %client.VStationRepairs =0;
//    %client.solarRepairs    =0;
//    %client.sentryRepairs   =0;
//    %client.depInvRepairs   =0;
//    %client.depTurretRepairs=0;
//   %client.returnPts = 0;
   %client.score = 0;
}

// Added SaNTa 19-03-03
function TAC_TDMGame::objectRepaired(%game, %obj, %objName)
{
   %item = %obj.getDataBlock().getName();
   switch$ (%item)
   {
      case generatorLarge :
         %game.genOnRepaired(%obj, %objName);
      case sensorMediumPulse :
         %game.sensorOnRepaired(%obj, %objName);
      case sensorLargePulse :
         %game.sensorOnRepaired(%obj, %objName);
      case stationInventory :
         %game.stationOnRepaired(%obj, %objName);
      case turretBaseLarge :
         %game.turretOnRepaired(%obj, %objName);
      case stationVehicle :
        %game.vStationOnRepaired(%obj, %objName);
      case solarPanel :
        %game.solarPanelOnRepaired(%obj, %objName);
      case sentryTurret :
        %game.sentryTurretOnRepaired(%obj, %objName);
      case TurretDeployedWallIndoor:
        %game.depTurretOnRepaired(%obj, %objName);
      case TurretDeployedFloorIndoor:
        %game.depTurretOnRepaired(%obj, %objName);
      case TurretDeployedCeilingIndoor:
        %game.depTurretOnRepaired(%obj, %objName);
      case TurretDeployedOutdoor:
        %game.depTurretOnRepaired(%obj, %objName);
   }
   %obj.wasDisabled = false;
}
// Added SaNTa 19-03-03
function TAC_TDMGame::genOnRepaired(%game, %obj, %objName)
{

   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgGenRepaired', '\c0%1 repaired the %2 Generator!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::stationOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgStationRepaired', '\c0%1 repaired the %2 Inventory Station!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::sensorOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgSensorRepaired', '\c0%1 repaired the %2 Pulse Sensor!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::turretOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgTurretRepaired', '\c0%1 repaired the %2 Turret!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::vStationOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgvstationRepaired', '\c0%1 repaired the Vehicle Station!', %repairman.name);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::solarPanelOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgsolarRepaired', '\c0%1 repaired the %2 Solar Panel!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::sentryTurretOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
      teamRepairMessage(%repairman, 'msgsentryTurretRepaired', '\c0%1 repaired the %2 Sentry Turret!', %repairman.name, %obj.nameTag);
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::depTurretOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::depInvOnRepaired(%game, %obj, %objName)
{
   if (%game.testValidRepair(%obj))
   {
      %repairman = %obj.repairedBy;
   }
}
// Added SaNTa 19-03-03
function TAC_TDMGame::testValidRepair(%game, %obj)
{
    if(!%obj.wasDisabled)
    {
        //error(%obj SPC "was never disabled");
        return false;
    }
    else if(%obj.lastDamagedByTeam == %obj.team)
    {
        //error(%obj SPC "was last damaged by a friendly");
        return false;
    }
    else if(%obj.team != %obj.repairedBy.team)
    {
        //error(%obj SPC "was repaired by an enemy");
        return false;
    }
    else
    {
        if(%obj.soiledByEnemyRepair)
            %obj.soiledByEnemyRepair = false;
        return true;
    }
}



