//**************************************************************
// THUNDERSWORD TAC2 BOMBER
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************
datablock AudioProfile(BomberFlyerEngineSound)
{
   filename    = "fx/vehicles/bomber_engine.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(BomberFlyerThrustSound)
{
   filename    = "fx/vehicles/bomber_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(FusionExpSound)
// Sound played when mortar impacts on target
{
   filename    = "fx/powered/turret_mortar_explode.wav";
   description = "AudioBIGExplosion3d";
   preload = true;
};

datablock AudioProfile(BomberTurretActivateSound)
{
   filename    = "fx/vehicles/bomber_turret_activate.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BomberTurretReloadSound)
{
   filename    = "fx/vehicles/bomber_turret_reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BomberTurretIdleSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = ClosestLooping3d;
   preload = true;
};

datablock AudioProfile(BomberTurretDryFireSound)
{
   filename    = "fx/vehicles/bomber_turret_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BomberBombReloadSound)
{
   filename    = "fx/vehicles/bomber_bomb_reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BomberBombProjectileSound)
{
   filename    = "fx/vehicles/bomber_bomb_projectile.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(BomberBombDryFireSound)
{
   filename    = "fx/vehicles/bomber_bomb_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BomberBombFireSound)
{
   filename    = "fx/vehicles/bomber_bomb_reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BomberBombIdleSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = ClosestLooping3d;
   preload = true;
};

datablock AudioProfile(ArgonTurretFireSound)
{
   filename    = "fx/weapons/TAC_Argon_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TACMiniGunSpinupSound)
{
   filename    = "fx/weapons/TAC_Minigun_Spinup.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(TACMiniGunSpinDownSound)
{
   filename    = "fx/weapons/TAC_Minigun_Spindown.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(TACMiniGunFireSound)
{
   filename    = "fx/weapons/TAC_Minigun_Fire.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(TACMiniGunDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};


//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock FlyingVehicleData(TACBomberFlyer) : BomberDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "tac_vehicle_air_bomber.dts";
   multipassenger = true;
   computeCRC = true;

   weaponNode = 1;

   renderWhenDestroyed = false;

   drag    = 0.2;
   density = 1.0;

   mountPose[0] = sitting;
   mountPose[1] = sitting;
   numMountPoints = 3;
   isProtectedMountPoint[0] = false;
   isProtectedMountPoint[1] = false;
   isProtectedMountPoint[2] = false;

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;

   cameraMaxDist = 22;
   cameraOffset = 5;
   cameraLag = 1.0;
   explosion = "VLExplosion";
   underwaterExplosion = "UnderwaterMExplosion";
	explosionDamage = 0.9;
	explosionRadius = 40.0;

   maxDamage = 3.00;     // Total health
   destroyedLevel = 3.00;   // Damage textures show up at this health level

   isShielded = false;
   energyPerDamagePoint = 150;
   maxEnergy = 600;      // Afterburner and any energy weapon pool
   minDrag = 80;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 2100;        // Angular Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.9;

   // Auto stabilize speed
   maxAutoSpeed = 0;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 1000;      // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 9;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 10;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 10;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 2900;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 700;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 350;      // Steering jets (how much you heel over when you turn)
   rollForce = 12;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 3;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 80;  // speed in which forward thrust force is no longer applied (meters/second)

   // Turbo Jet
   jetForce = 3200;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 30.0;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.9;       // Energy use of the afterburners (low number is less drain...can be fractional)
   vertThrustMultiple = 2.0;

   dustEmitter = LargeVehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 2.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "3.0 -3.0 0.0 ";
   damageEmitterOffset[1] = "-3.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 2;

   // Rigid body
   mass = 390;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.0;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 1;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 0.001;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.006;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 25;
   collDamageMultiplier   = 0.030;

   //
   minTrailSpeed = 40;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = FlyerJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = BomberFlyerThrustSound;
   engineSound = BomberFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 15.0;
   mediumSplashSoundVelocity = 20.0;
   hardSplashSoundVelocity = 30.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterHardSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterHardSound;
   waterWakeSound    = VehicleWakeHardSplashSound;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingHAPCIcon;
   cmdMiniIconName = "commander/MiniIcons/com_bomber_grey";
   targetNameTag = 'Thundersword';
   targetTypeTag = 'Bomber';
   sensorData = VehiclePulseSensor;

   checkRadius = 7.1895;
   observeParameters = "1 10 10";

   shieldEffectScale = "0.75 0.975 0.375";
};

//**************************************************************
// WEAPONS
//**************************************************************

//-------------------------------------
// BOMBER BELLY TURRET GUN (projectile)
//-------------------------------------

datablock EnergyProjectileData(TACArgonBolt)
{
   emitterDelay        = -1;
   directDamage        = 0.27;
   directDamageType    = $DamageType::Argon;
   kickBackStrength    = 1000.0;
   bubbleEmitTime      = 1.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.10;
   damageRadius        = 5.0;

   sound = BlasterProjectileSound;
   velInheritFactor    = 0.0;

   explosion           = PlasmaBoltExplosion;
   underwaterExplosion = UnderwaterHandGrenadeExplosion;
   splash              = PlasmaSplash;

   grenadeElasticity = 0.998;
   grenadeFriction   = 0.0;
   armingDelayMS     = 250;

   muzzleVelocity    = 300.0;

   drag = 0.05;

   gravityMod        = 0.0;

   dryVelocity       = 720.0;
   wetVelocity       = 250.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.5 0.175 0.175";

   scale = "0.25 20.0 1.0";
   crossViewAng = 0.99;
   crossSize = 0.55;

   lifetimeMS     = 5000;
   blurLifetime   = 0.2;
   blurWidth      = 0.25;
   blurColor = "0.4 0.0 0.0 1.0";

   texture[0] = "special/blasterBolt";
   texture[1] = "special/blasterBoltCross";
};


//-------------------------------------
// BOMBER BELLY TURRET CHARACTERISTICS
//-------------------------------------

datablock TurretData(TACBomberTurret) : TurretDamageProfile
{
   className      = VehicleTurret;
   catagory       = "Turrets";
   shapeFile      = "turret_belly_base.dts";
   preload        = true;

   mass           = 1.0;  // Not really relevant
   repairRate     = 0;
   maxDamage      = BomberFlyer.maxDamage;
   destroyedLevel = BomberFlyer.destroyedLevel;

   thetaMin = 90;
   thetaMax = 180;

   inheritEnergyFromMount = true;
   firstPersonOnly = true;
   useEyePoint = true;
   numWeapons = 3;

   targetNameTag = 'Thundersword Belly';
   targetTypeTag = 'Turret';
};

datablock TurretImageData(BomberTurretBarrelPair)
{
   shapeFile      = "turret_belly_barrell.dts";
   mountPoint = 0;

   projectile = TACArgonBolt;
   projectileType = EnergyProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 13.0;
   minEnergy = 13.0;

   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 360;
   degPerSecPhi      = 360;

   attackRadius      = 75;

   // State transitions
   stateName[0]                = "Activate";
   stateTransitionOnTimeout[0] = "WaitFire";
   stateTimeoutValue[0]        = 0.5;
   stateSequence[0]            = "Activate";
   stateSound[0]           = BomberTurretActivateSound;

   stateName[1] = "WaitFire";
   stateTransitionOnTriggerDown[1] = "InitFire";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";

   stateName[2] = "InitFire";
   stateWaitForTimeout[2]        = false;
   stateTransitionOnTimeout[2]   = "Fire";

   stateName[3]                = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3]        = 0.35;
   stateFire[3]                = true;
   stateRecoil[3]              = LightRecoil;
   stateAllowImageChange[3]    = false;
   stateSequence[3]            = "Fire";
   stateScript[3]              = "onFire";
   stateSound[3]               = ArgonTurretFireSound;

   stateName[4]                  = "Reload";
   stateTimeoutValue[4]          = 0.05;
   stateAllowImageChange[4]      = false;
   stateSequence[4]              = "Reload";
   stateTransitionOnTimeout[4]   = "WaitFire";
   stateTransitionOnNotLoaded[4] = "NoAmmo";
//   stateSound[4]                 = BomberTurretReloadSound;

   stateName[5]                    = "NoAmmo";
   stateTransitionOnAmmo[5]        = "Reload";
   stateSequence[5]                = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]                = "DryFire";
   stateSound[6]               = BomberTurretDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";

};

datablock TurretImageData(BomberTurretBarrel) : BomberTurretBarrelPair
{
   shapeFile      = "turret_belly_barrelr.dts";
   mountPoint = 1;
   stateScript[2]           = "onTriggerDown";
   stateScript[4]           = "onTriggerUp";
};

datablock TurretImageData(AIAimingTurretBarrel)
{
   shapeFile = "turret_muzzlepoint.dts";
   mountPoint = 3;

   projectile = TACArgonBolt;

   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 500;
   degPerSecPhi      = 800;

   attackRadius      = 75;
};

//-------------------------------------
// BOMBER BOMB PROJECTILE
//-------------------------------------

datablock BombProjectileData(BomberBomb)
{
   projectileShapeName = "bomb.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 1.1;
   damageRadius        = 30;
   radiusDamageType    = $DamageType::BomberBombs;
   kickBackStrength    = 3000;

   explosion           = "VehicleBombExplosion";
   velInheritFactor    = 1.0;

   grenadeElasticity = 0.25;
   grenadeFriction   = 0.4;
   armingDelayMS     = 2000;
   muzzleVelocity    = 0.8;
   drag              = 0.3;

   minRotSpeed       = "60.0 0.0 0.0";
   maxRotSpeed       = "80.0 0.0 0.0";
   scale             = "1.0 1.0 1.0";

   sound = BomberBombProjectileSound;
};

//-------------------------------------
// BOMBER BOMB CHARACTERISTICS
//-------------------------------------

datablock ItemData(BombAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "repair_kit.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 1;
   computeCRC = true;
};

datablock StaticShapeData(DropBombs)
{
   catagory       = "Turrets";
   shapeFile      = "bombers_eye.dts";
   maxDamage     = 1.0;
   disabledLevel  = 0.6;
   destroyedLevel = 0.8;
};

datablock ShapeBaseImageData(BomberBombPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
//   ammo = BombAmmo;
   offset = "2 -4 -0.5";
   mountPoint = 10;

   projectile = BomberBomb;
   projectileType = BombProjectile;
   usesEnergy = true;
   useMountEnergy = true;

   fireEnergy = 47.00;
   minEnergy = 50.00;

   stateName[0] = "Activate";
//   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTransitionOnTimeout[0] = "WaitFire";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
//   stateSound[0] = MortarSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "WaitFire";
//   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "WaitFire";
//   stateSound[2] = BomberBombIdleSound;
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "InitFire";

   stateName[3] = "InitFire";
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";

   stateName[4] = "Fire";
   stateTransitionOnTimeout[4] = "Reload";
   stateTimeoutValue[4] = 0.35;
   stateFire[4] = true;
   stateRecoil[4] = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4] = "onFire";
   stateSound[4] = BomberBombFireSound;

   stateName[5] = "Reload";
   stateTransitionOnNoAmmo[5] = "NoAmmo";
   stateTransitionOnTimeout[5] = "WaitFire";
   stateTimeoutValue[5] = 0.5;
   stateAllowImageChange[5] = false;
   stateSequence[5] = "Reload";
//   stateSound[5] = BomberBombReloadSound;

   stateName[6] = "NoAmmo";
   stateTransitionOnAmmo[6] = "Reload";
   stateSequence[6] = "NoAmmo";
   stateTransitionOnTriggerDown[6] = "DryFire";

   stateName[7]       = "DryFire";
   stateSound[7]      = BomberBombDryFireSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "NoAmmo";

};

datablock ShapeBaseImageData(BomberBombImage) : BomberBombPairImage
{
   offset = "-2 -4 -0.5";
   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
};


//-------------------------------------
// BOMBER BELLY TURRET MINIGUN (projectile)
//-------------------------------------

datablock TracerProjectileData(TACMiniGun)
{
   doDynamicClientHits = true;

   projectileShapeName = "";
   directDamage        = 0.05;
   directDamageType    = $DamageType::BellyTurret;
   hasDamageRadius     = false;
   splash			   = ChaingunSplash;
   kickbackstrength    = 0.0;
   sound          	   = TankChaingunProjectile;

   dryVelocity       = 425.0;
   wetVelocity       = 120.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   tracerLength    = 12.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;

   activateDelayMS   = 100;

   explosion = ChaingunExplosion;
};

//-------------------------------------
// BOMBER BELLY TURRET CHARACTERISTICS (projectile)
//-------------------------------------

datablock ShapeBaseImageData(TACBomberTurretVulcanBarrel)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";

   offset = "0 -0.04 -0.01";
   mountPoint = 2;

   projectile = TACMiniGun;
   projectileType = TracerProjectile;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 4.0;

   projectileSpread = 13.0 / 1000.0;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 4.5;
   minEnergy = 5;

   // Turret parameters
   activationMS      = 4000;
   deactivateDelayMS = 500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 360;
   degPerSecPhi      = 360;
   attackRadius      = 75;


   // State transitions
   stateName[0]                  	= "Activate";
   stateTransitionOnNotLoaded[0] 	= "Dead";
   stateTransitionOnLoaded[0]    	= "ActivateReady";
   stateSound[0]                 	= BomberTurretActivateSound;

   stateName[1]                  	= "ActivateReady";
   stateSequence[1]              	= "Activate";
   stateSound[1]                 	= BomberTurretActivateSound;
   stateTimeoutValue[1]          	= 1;
   stateTransitionOnTimeout[1]   	= "Ready";
   stateTransitionOnNotLoaded[1] 	= "Deactivate";

   stateName[2]                    	= "Ready";
   stateTransitionOnNotLoaded[2]   	= "Deactivate";
   stateTransitionOnTriggerDown[2] 	= "Spinup";

   stateName[3]         			= "Spinup";
   stateSpinThread[3]   			= SpinUp;
   stateSound[3]        			= TACMiniGunSpinupSound;
   stateTimeoutValue[3]          	= 1.0;
   stateWaitForTimeout[3]        	= true;
   stateTransitionOnTimeout[3]   	= "Fire";
   stateTransitionOnTriggerUp[3] 	= "Spindown";

   stateName[4]                		= "Fire";
   stateSequence[4]            		= "Fire";
   stateSequenceRandomFlash[4] 		= true;
   stateFire[4]                		= true;
   stateAllowImageChange[4]    		= false;
   stateSound[4]               		= TACMiniGunFireSound;
   stateScript[4]              		= "onFire";
   stateTimeoutValue[4]        		= 0.10;
   stateTransitionOnTimeout[4]   	= "Fire";
   stateTransitionOnTriggerUp[4] 	= "Spindown";
   stateTransitionOnNoAmmo[4]    	= "EmptySpindown";

   stateName[5]       				= "Spindown";
   stateSound[5]      				= TACMiniGunSpinDownSound;
   stateSpinThread[5] 				= SpinDown;
   stateTimeoutValue[5]            	= 1.0;
   stateWaitForTimeout[5]          	= true;
   stateTransitionOnTimeout[5]     	= "ActivateReady";
   stateTransitionOnTriggerDown[5] 	= "Spinup";

   stateName[6]       				= "EmptySpindown";
   stateSound[6]      				= TACMiniGunSpinDownSound;
   stateSpinThread[6] 				= SpinDown;
   stateTimeoutValue[6]        		= 0.5;
   stateTransitionOnTimeout[6] 		= "NoAmmo";

   stateName[7]                		= "Deactivate";
   stateSequence[7]            		= "Activate";
   stateDirection[7]           		= false;
   stateTimeoutValue[7]        		= 1;
   stateTransitionOnLoaded[7]  		= "ActivateReady";
   stateTransitionOnTimeout[7] 		= "Dead";

   stateName[8]               		= "Dead";
   stateTransitionOnLoaded[8] 		= "Ready";
   stateTransitionOnTriggerDown[8] 	= "DryFire";

   stateName[9]       				= "DryFire";
   stateSound[9]      				= TACMiniGunDryFireSound;
   stateTimeoutValue[9]        		= 0.5;
   stateTransitionOnTimeout[9] 		= "NoAmmo";

   stateName[10]                    = "NoAmmo";
   stateTransitionOnAmmo[10]        = "Ready";
   stateSequence[10]                = "NoAmmo";
   stateTransitionOnTriggerDown[10] = "DryFire";

};


//**************************************************************
// VEHICLE CREATION AND CLEANUP
//**************************************************************

function TACBomberFlyer::onAdd(%this, %obj)
{
   VehicleData::onAdd(%this, %obj);

   %turret = TurretData::create(TACBomberTurret);
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.selectedWeapon = 1;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(BomberTurretBarrel,2);
   %turret.mountImage(BomberTurretBarrelPair,3);
   %turret.mountImage(BomberBombImage, 4);
   %turret.mountImage(BomberBombPairImage, 5);
   %turret.mountImage(TACBomberTurretVulcanBarrel,6);
   %obj.turretObject = %turret;
   %turret.vehicleMounted = %obj;
   %turret.setAutoFire(false);
   %turret.mountImage(AIAimingTurretBarrel, 0);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
   %obj.schedule(8000, "playThread", $ActivateThread, "activate");

}

function TACBomberFlyer::deleteAllMounted(%data, %obj)
{
   if(isObject(%obj.beacon))
      %obj.beacon.delete();

   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
      return;

   %turret.altTrigger = 0;
   %turret.fireTrigger = 0;

   if(%client = %turret.getControllingClient())
   {
      commandToClient(%client, 'endBomberSight');
      %client.player.setControlObject(%client.player);
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
      %client.player.mountVehicle = false;

      %client.player.isBomber = false;
      %client.player.bomber = false;
   }
   %turret.delete();
}


function TACBomberFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "TACBomber", %node);
      commandToClient(%player.client, 'startBomberSight');
   }
   else if(%node == 1)
   {
      // bombardier position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      commandToClient(%player.client, 'startBomberSight');
      %turret.bomber = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

      setTargetSensorGroup(%turret.getTarget(), %player.client.getSensorGroup());
      setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "TACBomber", %node);
      %player.isBomber = true;

   }
   else
   {
      // tail gunner position
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "TACBomber", %node);
   }
   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
	// send names as well
	for(%i = 0; %i < %data.numMountPoints; %i++)
	{
		if(%obj.getMountNodeObject(%i) > 0)
		{
			%player = %obj.getMountNodeObject(%i);
			%cl = %player.client;
			%name = %cl.nameBase;
			for(%j = 0; %j < %data.numMountPoints; %j++)
			{
				if(%obj.getMountNodeObject(%j) > 0)
				{
				   	commandToClient(%obj.getMountNodeObject(%j).client, 'checkPassengerNames', %name, %i);
				}
			}
	    }
	}
}

function TACBomberFlyer::onTrigger(%data, %obj, %trigger, %state)
{
	if(%trigger == 0)
		switch (%state)
		{
			case 1:
				%obj.FixedRepairVehicle(0.5, 50, 320);
		}
}

function TACBomberFlyer::playerDismounted(%data, %obj, %player)
{

	%obj.RepairCheck = false;
	%obj.RepairVehicle(false);
	commandToClient(%player.client, 'endBomberSight');
	parent::playerDismounted(%data, %obj, %player);
}


//**************************************************************
// TURRET CODE
//**************************************************************


function TACBomberTurret::onDamage()
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function TACBomberTurret::damageObject(%this, %damageObj, %projectile, %amount, %damageType)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %damageObj.getObjectMount();
   %vehicle.getDataBlock().damageObject(%vehicle, %projectile, %amount, %damageType);
}

function TACBomberTurret::onTrigger(%data, %obj, %trigger, %state)
{
   //error("onTrigger: trigger = " @ %trigger @ ", state = " @ %state);
   //error("obj = " @ %obj @ ", class " @ %obj.getClassName());
   switch (%trigger)
   {
      case 0:
         %obj.fireTrigger = %state;
         if(%obj.selectedWeapon == 1)
         {
            %obj.setImageTrigger(4, false);
            if(%obj.getImageTrigger(6))
            {
               %obj.setImageTrigger(6, false);
               ShapeBaseImageData::deconstruct(%obj.getMountedImage(6), %obj);
            }
            if(%state)
               %obj.setImageTrigger(2, true);
            else
               %obj.setImageTrigger(2, false);
         }
         else if(%obj.selectedWeapon == 2)
         {
            %obj.setImageTrigger(2, false);
            if(%obj.getImageTrigger(6))
            {
               %obj.setImageTrigger(6, false);
               ShapeBaseImageData::deconstruct(%obj.getMountedImage(6), %obj);
            }
            if(%state)
               %obj.setImageTrigger(4, true);
            else
               %obj.setImageTrigger(4, false);
         }
         else
         {
            %obj.setImageTrigger(2, false);
            %obj.setImageTrigger(4, false);
            if(%state)
               %obj.setImageTrigger(6, true);
               
            else
            {
               %obj.setImageTrigger(6, false);
               ShapeBaseImageData::deconstruct(%obj.getMountedImage(6), %obj);
               // The next line killed by SaNTa and replaced with the one above.
               // BomberTargetingImage::deconstruct(%obj.getMountedImage(6), %obj);
            }
         }

      case 2:
         if(%state)
         {
            %obj.getDataBlock().playerDismount(%obj);
         }
   }
}

function TACBomberTurret::playerDismount(%data, %obj)
{
   //Passenger Exiting
   %obj.fireTrigger = 0;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(4, false);
   %obj.setImageTrigger(6, false);
   %client = %obj.getControllingClient();
   %client.player.isBomber = false;
   commandToClient(%client, 'endBomberSight');

//   %client.player.setControlObject(%client.player);
   %client.player.mountVehicle = false;
//   %client.player.getDataBlock().doDismount(%client.player);
   if(%client.player.getState() !$= "Dead")
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
   setTargetSensorGroup(%obj.getTarget(), 0);
   setTargetNeverVisMask(%obj.getTarget(), 0xffffffff);
}


function AIAimingTurretBarrel::onFire(%this,%obj,%slot)
{
}


function BomberTurretBarrel::onTriggerDown(%this, %obj, %slot)
{
   %obj.turretBarrelSchedule = %obj.schedule(300, "setImageTrigger", 3, true);
}

function BomberTurretBarrel::onTriggerUp(%this, %obj, %slot)
{
   cancel(%obj.turretBarrelSchedule);
   %obj.setImageTrigger( 3, false);
}

function BomberTurretBarrelPair::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function BomberArgonBarrel::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function TACBomberTurretVulcanBarrel::onTriggerDown(%this, %obj, %slot)
{
   //%obj.schedule(300, "setImageTrigger", 3, true);
}

function TACBomberTurretVulcanBarrel::onTriggerUp(%this, %obj, %slot)
{
   //%obj.schedule(400, "setImageTrigger", 3, false);
}

function TACBomberTurretVulcanBarrel::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function BomberBombImage::onTriggerDown(%this, %obj, %slot)
{
   %obj.schedule(500, "setImageTrigger", 5, true);
}

function BomberBombImage::onTriggerUp(%this, %obj, %slot)
{
   %obj.schedule(600, "setImageTrigger", 5, false);
}

function BomberBombPairImage::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function BomberBombImage::onMount(%this, %obj, %slot)
{
}

function BomberBombImage::onUnmount(%this,%obj,%slot)
{
}

function BomberBombPairImage::onUnmount(%this,%obj,%slot)
{
}
