//=====================================================================================
//	TAC2 - Vehicle Code - Hawkeye								Wizard_TPG - 15/3/2001
//
//	This code includes:
//				Declaration of TAC Hawkeye
//				Weaponry - 	Mini-Gun Cannons
//							Tag Cannon
//
//         SaNTa changed all the datablocks that were in
//         conflict with the bomber. They are now called TACHawkeye 12-October-2002
//=====================================================================================

//**************************************************************
// SOUNDS
//**************************************************************

datablock AudioProfile(ScoutFlyerThrustSound)
{
   filename    = "fx/vehicles/shrike_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(ScoutFlyerEngineSound)
{
   filename    = "fx/vehicles/shrike_engine.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(TACHawkeyeTurretActivateSound)
{
   filename    = "fx/vehicles/bomber_turret_activate.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TACHawkeyeTurretReloadSound)
{
   filename    = "fx/vehicles/bomber_turret_reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TACHawkeyeTurretIdleSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = ClosestLooping3d;
   preload = true;
};

datablock AudioProfile(TAGCannonFireSound)
{
   filename    = "fx/weapons/TAC_Tag_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TACHawkeyeTargetingSwitchSound)
{
   filename    = "fx/weapons/generic_switch.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(TACHawkeyeTargetingPaintSound)
{
   filename    = "fx/weapons/targetinglaser_paint.wav";
   description = CloseLooping3d;
   preload = true;
};


//**************************************************************
// LIGHTS
//**************************************************************
datablock RunningLightData(ShrikeLight1)
{
   type        = 1;
   radius      = 2.0;
   length      = 3.0;
   color       = "1.0  1.0  1.0  1.0";
   direction   = "0.0  1.0 -1.0 ";
   offset      = "0.0  0.0 -0.5";
   texture     = "special/lightcone04";
};

datablock RunningLightData(ShrikeLight2)
{
   radius = 1.5;
   color = "1.0 1.0 1.0 0.3";
   direction = "0.0 0.0 -1.0";
   offset      = "0.0  0.8 -1.2";
   texture = "special/headlight4";
};

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock FlyingVehicleData(TACScoutFlyer) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "hawkeye.dts";
   computeCRC = true;

   weaponNode = 1;

   renderWhenDestroyed = false;

   multipassenger = true;
   mountPose[0] = sitting;
   mountPose[1] = sitting;
   numMountPoints = 2;

   isProtectedMountPoint[0] = false;
   isProtectedMountPoint[1] = false;

   drag    = 0.15;
   density = 1.0;

   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = "SExplosion";
   underwaterExplosion = "UnderwaterMExplosion";
	explosionDamage = 0.05;
	explosionRadius = 10.0;

   maxDamage = 0.40;
   destroyedLevel = 0.40;

   isShielded = false;
   energyPerDamagePoint = 160;
   maxEnergy = 420;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.9;

   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 400;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 2400;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1400;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 500;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 3;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 145;  // speed in which forward thrust force is no longer applied (meters/second)

   // Turbo Jet
   jetForce = 7000;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 45;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.5;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 3.0;

   // Rigid body
   mass = 150;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.0;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 1;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 0.001;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.006;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 25.0;
   collDamageMultiplier   = 0.02;

   //
   minTrailSpeed = 60;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = FlyerJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = ScoutFlyerThrustSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 15.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   //
   max[chaingunAmmo] = 1000;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Hawkeye';
   targetTypeTag = 'Flying Vehicle';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";

   checkRadius = 5.5;
   observeParameters = "1 10 10";

   runningLight[0] = ShrikeLight1;

   shieldEffectScale = "0.937 1.125 0.60";

};


//**************************************************************
// TURRET
//**************************************************************

datablock TurretData(HawkeyeTurret)
{
   className      = VehicleTurret;
   catagory       = "Turrets";
   shapeFile      = "tag cannon.dts";

   preload        = true;
   mass           = 1.0;  // Not really relevant
   repairRate     = 0;
   thetaMin = 0;
   thetaMax = 180;
   inheritEnergyFromMount = true;
   firstPersonOnly = true;
   useEyePoint = true;
   numWeapons = 2;
   targetNameTag = 'Hawkeye Underbelly';
   targetTypeTag = 'Turret';
   computeCRC = true;
};


//**************************************************************
// TAG CANNON
//**************************************************************

datablock StaticShapeData(DeployedTAGBeacon)
{
   	shapeFile = "tag projectile.dts";
   	beacon = true;
   	targetNameTag = 'TAG Beacon';
   	beaconType = enemy;
   	isInvincible = false;
   	dynamicType = $TypeMasks::SensorObjectType;

   	maxDamage = 0.3;
   	destroyedLevel = 0.3;
   	disabledLevel = 0.3;
};

datablock LinearProjectileData(TACCannonProjectile)
{
   projectileShapeName = "tag projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = false;
   indirectDamage      = 0.00;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::Disc;
   kickBackStrength    = 0;

   sound 			   = BlasterProjectileSound;
   explosion           = ChaingunExplosion;
   underwaterExplosion = ChaingunExplosion;
   splash              = ChaingunSplash;

   dryVelocity       = 1000;
   wetVelocity       = 1000;
   velInheritFactor  = 1.0;
   lifetimeMS        = 6000;
   fizzleTimeMS      = 5000;
   fizzleUnderwaterMS        = 4000;

   activateDelayMS = -1;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.01 0.4 0.0";

   lifetimeMS     = 5000;
   blurLifetime   = 0.25;
   blurWidth      = 0.40;
   blurColor = "0.0 0.5 0.0 1.0";
};

datablock ShapeBaseImageData(TACHawkeyeTagCannonBarrel)
{
   shapeFile = "turret_muzzlepoint.dts";
   offset = "0 -0.04 -0.05";
   mountPoint = 1;

   projectile = TACCannonProjectile;
   projectileType = LinearProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 100;
   minEnergy = 100;

   // Turret parameters
   activationMS      = 4000;
   deactivateDelayMS = 500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 360;
   degPerSecPhi      = 360;
   attackRadius      = 75;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "WaitFire";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "WaitFire";

   stateName[2] = "WaitFire";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "InitFire";

   stateName[3] = "InitFire";
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";

   stateName[4] = "Fire";
   stateTransitionOnTimeout[4] = "Reload";
   stateTimeoutValue[4] = 0.35;
   stateFire[4] = true;
   stateRecoil[4] = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4] = "onFire";
   stateSound[4] = TAGCannonFireSound;

   stateName[5] = "Reload";
   stateTransitionOnNoAmmo[5] = "NoAmmo";
   stateTransitionOnTimeout[5] = "WaitFire";
   stateTimeoutValue[5] = 2.0;
   stateAllowImageChange[5] = false;
   stateSequence[5] = "Reload";

   stateName[6] = "NoAmmo";
   stateTransitionOnAmmo[6] = "Reload";
   stateSequence[6] = "NoAmmo";
   stateTransitionOnTriggerDown[6] = "DryFire";

   stateName[7]       = "DryFire";
   stateSound[7]      = BomberBombDryFireSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "NoAmmo";
};


//**************************************************************
// TARGETTING LASER
//**************************************************************

//--------------------------------------
// TACHawkeye TARGETING PROJECTILE
//--------------------------------------
datablock TargetProjectileData(TACHawkeyeTargeter)
{
   directDamage         = 0.0;
   hasDamageRadius      = false;
   indirectDamage       = 0.0;
   damageRadius         = 0.0;
   velInheritFactor     = 1.0;

   maxRifleRange        = 1000;
   beamColor            = "0.1 1.0 0.1";

   startBeamWidth       = 0.20;
   pulseBeamWidth       = 0.15;
   beamFlareAngle       = 3.0;
   minFlareSize         = 0.0;
   maxFlareSize         = 400.0;
   pulseSpeed           = 6.0;
   pulseLength          = 0.150;

   textureName[0]       = "special/nonlingradient";
   textureName[1]       = "special/flare";
   textureName[2]       = "special/pulse";
   textureName[3]      	= "special/expFlare";
};

//-------------------------------------
// TACHawkeye TARGETING CHARACTERISTICS
//-------------------------------------
datablock ShapeBaseImageData(TACHawkeyeBomberTargetingImage)
{
   className                           = WeaponImage;

   shapeFile                           = "turret_muzzlepoint.dts";
   offset                              = "0 -0.04 -0.05";
   mountPoint                          = 2;

   projectile                          = TACHawkeyeTargeter;
   projectileType                      = TargetProjectile;
   deleteLastProjectile                = true;

   usesEnergy                          = true;
   minEnergy                           = 3;

   stateName[0]                        = "Activate";
   stateSequence[0]                    = "Activate";
   stateSound[0]                       = TACHawkeyeTargetingSwitchSound;
   stateTimeoutValue[0]                = 0.5;
   stateTransitionOnTimeout[0]         = "ActivateReady";

   stateName[1]                        = "ActivateReady";
   stateTransitionOnAmmo[1]            = "Ready";
   stateTransitionOnNoAmmo[1]          = "NoAmmo";

   stateName[2]                        = "Ready";
   stateTransitionOnNoAmmo[2]          = "NoAmmo";
   stateTransitionOnTriggerDown[2]     = "Fire";

   stateName[3]                        = "Fire";
   stateEnergyDrain[3]                 = 3;
   stateFire[3]                        = true;
   stateAllowImageChange[3]            = false;
   stateScript[3]                      = "onFire";
   stateTransitionOnTriggerUp[3]       = "Deconstruction";
   stateTransitionOnNoAmmo[3]          = "Deconstruction";
   stateSound[3]                       = TACHawkeyeTargetingPaintSound;

   stateName[4]                        = "NoAmmo";
   stateTransitionOnAmmo[4]            = "Ready";

   stateName[5]                        = "Deconstruction";
   stateTransitionOnTimeout[5]         = "ActivateReady";
   stateTimeoutValue[5]                = 0.05;
};


//-------------------------------------
// TACHawkeye BEACON
//-------------------------------------
datablock StaticShapeData(TACHawkeyeBeacon)
{
   shapeFile = "turret_muzzlepoint.dts";
   targetNameTag = 'beacon';
   isInvincible = true;

   dynamicType = $TypeMasks::SensorObjectType;
};



//**************************************************************
// VEHICLE CREATION AND CLEANUP
//**************************************************************

function TACScoutFlyer::onAdd(%this, %obj)
{
	VehicleData::onAdd(%this, %obj);

	%turret = TurretData::create(HawkeyeTurret);
	MissionCleanup.add(%turret);
	%turret.team = %obj.teamBought;
	%turret.selectedWeapon = 1;
	%turret.setSelfPowered();
	%obj.mountObject(%turret, 10);
	%turret.mountImage(TACHawkeyeTagCannonBarrel,2);
	%turret.mountImage(TACHawkeyeBomberTargetingImage,4);
	%obj.turretObject = %turret;
	%turret.vehicleMounted = %obj;

	//vehicle turrets should not auto fire at targets
	%turret.setAutoFire(false);

	//for this particular weapon - a non-firing datablock used only so the AI can aim the turret
	//Also needed so we can set the turret parameters..
	setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);

   %obj.schedule(8000, "playThread", $ActivateThread, "activate");
}

function TACScoutFlyer::deleteAllMounted(%data, %obj)
{
   if(isObject(%obj.beacon))
      %obj.beacon.delete();

   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
      return;

   %turret.altTrigger = 0;
   %turret.fireTrigger = 0;

   if(%client = %turret.getControllingClient())
   {
      %client.player.setControlObject(%client.player);
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
      %client.player.mountVehicle = false;
      %client.player.TACHawkeye = false;
   }
   %turret.delete();
}


function TACScoutFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', 'HawkEye', %node);
   }
   else
   {
      // Gunner position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
         %player.setControlObject(%turret);
      %turret.TACHawkeye = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

      setTargetSensorGroup(%turret.getTarget(), %player.client.getSensorGroup());
      setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', 'HawkEye', %node);
   }
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
	// send names as well
	for(%i = 0; %i < %data.numMountPoints; %i++)
	{
		if(%obj.getMountNodeObject(%i) > 0)
		{
			%player = %obj.getMountNodeObject(%i);
			%cl = %player.client;
			%name = %cl.nameBase;
			//%name = detag(%name);
			for(%j = 0; %j < %data.numMountPoints; %j++)
			{
				if(%obj.getMountNodeObject(%j) > 0)
				{
				   	commandToClient(%obj.getMountNodeObject(%j).client, 'checkPassengerNames', %name, %i);
				}
			}
	    }
	}
}


function TACScoutFlyer::onTrigger(%data, %obj, %trigger, %state)
{
	if(%trigger == 0)
		switch (%state)
		{
			case 0:
				if(%obj.CloakCheck)
				{
					%obj.CloakCheck = false;
					%obj.CloakVehicle(false, 3, %obj.lastPilot, %obj.turretObject, %obj.turretObject.TACHawkeye);
				}
				else
				{
					%obj.CloakCheck = true;
					%obj.CloakVehicle(true, 3, %obj.lastPilot, %obj.turretObject, %obj.turretObject.TACHawkeye);
				}
			case 1:


		}
}

function TACScoutFlyer::playerDismounted(%data, %obj, %player)
{
   %player.setCloaked(false);
	%obj.CloakCheck = false;
	%obj.CloakVehicle(false, 4, %obj.lastPilot, %obj.turretObject, %obj.turretObject.TACHawkeye);
	parent::playerDismounted(%data, %obj, %player);
}

function TACScoutFlyer::onDestroyed(%data, %obj, %prevState)
{
   // ~ hawkeye fix
   $HawkeyeUsed[%obj.team] = true;

	%obj.CloakCheck = false;
	%obj.CloakVehicle(false, 4, %obj.lastPilot);
	parent::onDestroyed(%data, %obj, %prevState);
}

//function HawkeyeTurret::playerDismount(%data, %obj)
//{
//   %client = %obj.getControllingClient();
//   %player = %client.player;
//   %player.setCloaked(false);
//	AssaultPlasmaTurret::playerDismount(%data, %obj);
//}


//**************************************************************
//	TURRET CODE
//**************************************************************

function HawkeyeTurret::onDamage()
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function HawkeyeTurret::damageObject(%this, %damageObj, %projectile, %amount, %damageType)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %damageObj.getObjectMount();
   %vehicle.getDataBlock().damageObject(%vehicle, %projectile, %amount, %damageType);
}

function HawkeyeTurret::playerDismount(%data, %obj)
{
	%client = %obj.getControllingClient();
	%player = %client.player;
	%player.setCloaked(false);
	%obj.TACHawkeye = 0;
	%player.vehicleTurret = 0;
	AssaultPlasmaTurret::playerDismount(%data, %obj);
}

function HawkeyeTurret::onTrigger(%data, %obj, %trigger, %state)
{
   switch (%trigger)
   {
		case 0:
         %obj.fireTrigger = %state;
         if(%obj.selectedWeapon == 1)
         {
			if(%obj.getImageTrigger(4))
			{
			   %obj.setImageTrigger(4, false);
			   //ShapeBaseImageData::deconstruct(%obj.getMountedImage(4), %obj);
               TACHawkeyeTargetingImage::deconstruct(%obj.getMountedImage(4), %obj);
            }
            if(%state)
               %obj.setImageTrigger(2, true);
            else
               %obj.setImageTrigger(2, false);
         }
         else
         {
            %obj.setImageTrigger(2, false);
            if(%state)
               %obj.setImageTrigger(4, true);
            else
            {
               %obj.setImageTrigger(4, false);
               TACHawkeyeTargetingImage::deconstruct(%obj.getMountedImage(4), %obj);
            }
         }
		case 2:
			if(%state)
         {
		      %obj.getDataBlock().playerDismount(%obj);
         }
   }
}



//**************************************************************
// TAG CANNON CODE
//**************************************************************

function TACCannonProjectile::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
	%classname = %targetObject.getclassname();
	if(%classname $= "Player")
	{
	     //Dont attach to players
	}
	else if(%targetObject.getName() $= Terrain || %targetObject.getclassname() $= "InteriorInstance" ||
   	%targetObject.getclassname() $= "StaticShape" || %targetObject.getclassname() $= "Turret")
   	{
		%vehicle = %projectile.vehicleobject;
		%vehicleteam = %vehicle.team;
		%depTAG = new BeaconObject()
		{
			dataBlock = "DeployedTAGBeacon";
			position = %position;
			owner = %vehicle.turret.TACHawkeye.client;
		};
		%depTAG.playThread($AmbientThread, "ambient");
   		%depTAG.team = %vehicleteam;
   		%depTAG.sourceObject = %TACHawkeye;

   		%depTAG.setTarget(%vehicleteam);
   		MissionCleanup.add(%depTAG);
		schedule(60000,%depTAG,"RemoveTAGBeacon",%depTAG, true);
	}
	else
	{
		%vehicle = %projectile.vehicleobject;
		%vehicleteam = %vehicle.team;

		%depTAG = new BeaconObject()
		{
			dataBlock = "DeployedTAGBeacon";
			team = %vehicleteam;
			sourceObject = %vehicle;
			owner = %vehicle.turret.TACHawkeye.client;

		};
		%depTAG.playThread($AmbientThread, "ambient");
   		%depTAG.team = %vehicleteam;
   		%depTAG.sourceObject = %TACHawkeye;

	   	%depTAG.setTarget(%vehicleteam);
   		MissionCleanup.add(%depTAG);
		%targetObject.mountObject(%depTAG, 11);
		schedule(60000,%depTAG,"RemoveTAGBeacon",%depTAG, true);
	}

	Parent::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal);
}

function DeployedTAGBeacon::onDestroyed(%data, %obj, %prevState)
{
	Parent::onDestroyed(%data, %obj, %prevState);
	RemoveTAGBeacon(%obj, true);
}

function RemoveTAGBeacon(%this, %fixed)
{
	%this.schedule(50, delete);
}

function TACHawkeyeTagCannonBarrel::onFire(%data,%obj,%slot)
{
   	%p = Parent::onFire(%data, %obj, %slot);
   	%p.setTarget(%obj.team);
}

function TACHawkeyeTagCannonBarrel::onTriggerDown(%this, %obj, %slot)
{
   //%obj.schedule(300, "setImageTrigger", 3, true);
}

function TACHawkeyeTagCannonBarrel::onTriggerUp(%this, %obj, %slot)
{
   //%obj.schedule(400, "setImageTrigger", 3, false);
}

function TACHawkeyeTagCannonBarrel::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function TACHawkeyeTagCannonBarrel::onUnmount(%this,%obj,%slot)
{
}



//**************************************************************
// TARGETTING LASER CODE
//**************************************************************

function TACHawkeyeTargetingImage::onFire(%data,%obj,%slot)
{
   %TACHawkeye = %obj.getObjectMount();
   if(%TACHawkeye.beacon)
   {
      %TACHawkeye.beacon.delete();
      %TACHawkeye.beacon = "";
   }
   %p = Parent::onFire(%data, %obj, %slot);
   %p.setTarget(%obj.team);
}

function TACHawkeyeTargetingImage::deconstruct(%data, %obj, %slot)
{
   if(isObject(%obj.lastProjectile))
   		%pos = %obj.lastProjectile.getTargetPoint();
   %TACHawkeye = %obj.getObjectMount();

   if(%TACHawkeye.beacon)
   {
      %TACHawkeye.beacon.delete();
      %TACHawkeye.beacon = "";
   }
   %TACHawkeye.beacon = new BeaconObject()
    {
      dataBlock = "TACHawkeyeBeacon";
      beaconType = "vehicle";
      position = %pos;
   };

   %TACHawkeye.beacon.playThread($AmbientThread, "ambient");
   %TACHawkeye.beacon.team = %TACHawkeye.team;
   %TACHawkeye.beacon.sourceObject = %TACHawkeye;

   // give it a team target
   %TACHawkeye.beacon.setTarget(%TACHawkeye.team);
   MissionCleanup.add(%TACHawkeye.beacon);

   //echo("parent deconstruct");
   ShapeBaseImageData::deconstruct(%data, %obj, %slot);
}
