//**************************************************************
// JERICHO FORWARD BASE (Mobile Point Base)
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************
datablock EffectProfile(MPBEngineEffect)
{
   effectname = "vehicles/mpb_thrust";
   minDistance = 5.0;
   maxDistance = 10.0;
};

datablock EffectProfile(MPBThrustEffect)
{
   effectname = "vehicles/mpb_boost";
   minDistance = 5.0;
   maxDistance = 10.0;
};

datablock AudioProfile(MPBEngineSound)
{
   filename    = "fx/vehicles/mpb_thrust.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   effect = MPBEngineEffect;
};

datablock AudioProfile(MPBThrustSound)
{
   filename    = "fx/vehicles/mpb_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   effect = MPBThrustEffect;
};

datablock AudioProfile(MobileBaseDeploySound)
{
   filename    = "fx/vehicles/MPB_deploy.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MobileBaseUndeploySound)
{
   filename    = "fx/vehicles/MPB_undeploy_turret.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MobileBaseTurretDeploySound)
{
   filename    = "fx/vehicles/MPB_deploy_turret.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MobileBaseTurretUndeploySound)
{
   filename    = "fx/vehicles/MPB_undeploy_turret.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MobileBaseStationDeploySound)
{
   filename    = "fx/vehicles/MPB_deploy_station.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MobileBaseStationUndeploySound)
{
   filename    = "fx/vehicles/MPB_close_lid.wav";
   description = AudioClose3d;
   preload = true;
};


//**************************************************************
// LIGHTS
//**************************************************************
datablock RunningLightData(MPBLight1)
{
   pointSize = 3.0;
   pointColor = "1.0 1.0 1.0 0.3";
   pointNodeName = "Headlight_node01";
   texture = "special/expFlare";
};

datablock RunningLightData(MPBLight2)
{
   pointSize = 3.0;
   pointColor = "1.0 1.0 1.0 0.3";
   pointNodeName = "Headlight_node02";
   texture = "special/expFlare";
};


//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************
datablock SensorData(MPBDeployedSensor) : VehiclePulseSensor
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = true;
   detectsActiveJammed = true;
   detectsCloaked = true;
   detectionPings = true;
   detectRadius = 20;
   jams = true;
   jamsOnlyGroup = true;
   jamsUsingLOS = false;
   jamRadius = 75;
};

datablock WheeledVehicleData(TACMobileBaseVehicle) : MPBDamageProfile
{
   spawnOffset = "0 0 1.0";
   renderWhenDestroyed = false;

	canDeploy = true;

   catagory = "Vehicles";
   shapeFile = "tac_vehicle_land_mpbase.dts";
   multipassenger = false;
   computeCRC = true;

   
   drag = 0.0;
   density = 20.0;

   mountPose[0] = sitting;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;

   cantAbandon = 1;
   cantTeamSwitch = 1;

   cameraMaxDist = 20;
   cameraOffset = 6;
   cameraLag = 1.5;
   explosion = "VLExplosion";
   explosionDamage = 2.8;
   explosionRadius = 50.0;

   maxSteeringAngle = 0.3;  // 20 deg.

   // Used to test if the station can deploy
   stationPoints[1] = "-2.3 -7.38703 -0.65";
   stationPoints[2] = "-2.3 -11.8 -0.65";
   stationPoints[3] = "0 -7.38703 -0.65";
   stationPoints[4] = "0 -11.8 -0.65";
   stationPoints[5] = "2.3 -7.38703 -0.65";
   stationPoints[6] = "2.3 -11.8 -0.65";

   // Rigid Body
   mass = 2000;
   bodyFriction = 0.8;
   bodyRestitution = 0.5;
   minRollSpeed = 3;
   gyroForce = 400;
   gyroDamping = 0.3;
   stabilizerForce = 12;
   minDrag = 10;
   softImpactSpeed = 35;       // Play SoftImpact Sound
   hardImpactSpeed = 45;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 35;
   speedDamageScale = 0.060;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 30;
   collDamageMultiplier   = 0.080;

   // Engine
   engineTorque = 10.0 * 745;
   breakTorque = 12.0 * 745;
   maxWheelSpeed = 6;

   // Springs
   springForce = 8000;
   springDamping = 1300;
   antiSwayForce = 6000;
   staticLoadScale = 2;

   // Tires
   tireRadius = 1.6;
   tireFriction = 10.0;
   tireRestitution = 0.5;
   tireLateralForce = 3000;
   tireLateralDamping = 400;
   tireLateralRelaxation = 1;
   tireLongitudinalForce = 12000;
   tireLongitudinalDamping = 600;
   tireLongitudinalRelaxation = 1;
   tireEmitter = TireEmitter;

   //
   maxDamage = 6.00;
   destroyedLevel = 6.00;

   isShielded = true;
   energyPerDamagePoint = 115;
   maxEnergy = 600;
   jetForce = 3000;
   minJetEnergy = 60;
   jetEnergyDrain = 2.3;
   rechargeRate = 1.0;

   jetSound = MPBThrustSound;
   engineSound = MPBEngineSound;
   squeelSound = AssaultVehicleSkid;
   softImpactSound = GravSoftImpactSound;
   hardImpactSound = HardImpactSound;
//   wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 5.0;
   mediumSplashSoundVelocity = 8.0;
   hardSplashSoundVelocity = 12.0;
   exitSplashSoundVelocity = 8.0;

   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterHardSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   minMountDist = 3;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "3.0 0.5 0.0 ";
   damageEmitterOffset[1] = "-3.0 0.5 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 2;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDGroundMPBIcon;
   cmdMiniIconName = "commander/MiniIcons/com_mpb_grey";
   targetNameTag = 'Jericho';
   targetTypeTag = 'MPB';
   sensorData = VehiclePulseSensor;

   checkRadius = 7.5225;

   observeParameters = "1 12 12";

   runningLight[0] = MPBLight1;
   runningLight[1] = MPBLight2;

   shieldEffectScale = "0.85 1.2 0.7";
};

//**************************************************************
// WEAPONS
//**************************************************************

datablock SensorData(MPBTurretMissileSensor)
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = true;
   detectsActiveJammed = true;
   detectsCloaked = true;
   detectionPings = true;
   detectRadius = 300;
};

datablock TurretData(MobileTurretBase)
{
   className      = VehicleTurret;
   catagory       = "Turrets";
   shapeFile      = "turret_base_mpb.dts";
   preload        = true;

   mass           = 1.0;  // Not really relevant

   maxDamage      = MobileBaseVehicle.maxDamage;
   destroyedLevel = MobileBaseVehicle.destroyedLevel;

   thetaMin      = 15;
   thetaMax      = 140;

   energyPerDamagePoint = 33;
   inheritEnergyFromMount = true;
   firstPersonOnly = true;

   sensorColor = "0 212 45";
   sensorData = MPBTurretMissileSensor;
   sensorRadius = MPBTurretMissileSensor.detectRadius;
   cmdCategory = "Tactical";
   cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
   targetNameTag = 'Jericho';
   targetTypeTag = 'Turret';

   canControl = false;
};


//**************************************************************
// VEHICLE CODE
//**************************************************************

function TACMobileBaseVehicle::onAdd(%this, %obj)
{
	Parent::onAdd(%this, %obj);
	%obj.station = "";
	%obj.turret = "";
	%obj.beacon = "";
	%obj.canDeploy = true;
	%obj.schedule(5000, "playThread", $AmbientThread, "ambient");
   	%obj.schedule(8000, "playThread", $ActivateThread, "activate");
}

function TACMobileBaseVehicle::deleteAllMounted(%data, %obj)
{
   if(isObject(%obj.station))
   {
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.unmountObject(%obj.station);
      %obj.station.trigger.delete();
      %obj.station.delete();
   }
   if(isObject(%obj.turret))
   {
      %obj.turret.getDataBlock().onLosePowerDisabled(%obj.turret);
      %obj.unmountObject(%obj.turret);
      %obj.turret.delete();
   }
   if(isObject(%obj.shield))
      %obj.shield.delete();

   if(isObject(%obj.beacon))
   {
      %obj.beacon.delete();
   }
}


function TACMobileBaseVehicle::playerMounted(%data, %obj, %player, %node)
{
   	// MPB vehicle == SUV (single-user vehicle)
   	commandToClient(%player.client, 'setHudMode', 'Pilot', "MPB", %node);
   	%player.mpbpilot = %obj;

	if(!%obj.canDeploy)
	{
		%artifact = Game.artifact;
		%obj.unmountObject(%artifact);
		%obj.mountObject(%artifact, 1);
		%obj.canDeploy = false;
		return;
	}

   if(%obj.deploySchedule)
   {
      %obj.deploySchedule.clear();
      %obj.deploySchedule = "";
   }

   if(%obj.deployed !$= "" && %obj.deployed == 1)
   {
      %obj.setThreadDir($DeployThread, false);
      %obj.playThread($DeployThread,"deploy");
      %obj.playAudio($DeploySound, MobileBaseUndeploySound);
      %obj.station.setThreadDir($DeployThread, false);
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.station.clearSelfPowered();
      %obj.station.goingOut=false;
      %obj.station.notDeployed = 1;
      %obj.station.playAudio($DeploySound, MobileBaseStationUndeploySound);

      if((%turretClient = %obj.turret.getControllingClient()) !$= "")
      {
         CommandToServer( 'resetControlObject', %turretClient );
      }

      %obj.turret.setThreadDir($DeployThread, false);
      %obj.turret.clearTarget();
      %obj.turret.setTarget(-1);

      %obj.turret.playAudio($DeploySound, MobileBaseTurretUndeploySound);
      %obj.shield.open();
      %obj.shield.schedule(1000,"delete");
      %obj.deploySchedule = "";
      %obj.fullyDeployed = 0;

      %obj.noEnemyControl = 0;
   }
   %obj.deployed = 0;
}

function buildPassengerString(%vehicle)
{
   %passStr = "";
   for(%i = 0; %i < %vehicle.getDatablock().numMountPoints; %i++)
   {
      if(%vehicle.getMountNodeObject(%i) > 0)
         %passStr = %passStr @ "1 ";
      else
         %passStr = %passStr @ "0 ";
   }

   return %passStr;
}

function TACMobileBaseVehicle::playerDismounted(%data, %obj, %player)
{
   parent::playerDismounted(%data, %obj, %player);
   %player.mpbpilot = 0;
   %obj.schedule(500, "deployVehicle", %data, %player);
}

function WheeledVehicle::deployVehicle(%obj, %data, %player)
{
   if(!%obj.canDeploy)
   		return;

   if (!%data.vehicleDeploy(%obj, %player))
      %obj.schedule(500, "deployVehicle", %data, %player);
}


function TACMobileBaseVehicle::vehicleDeploy(%data, %obj, %player, %force)
{
   if(!%obj.canDeploy)
   		return false;

   if(VectorLen(%obj.getVelocity()) <= 0.1 || %force)
   {
	  	%deployMessage = "";
		 if(%obj.station $= "")
		 {
			if( (%deployMessage = %data.checkDeploy(%obj)) $= "" || %force)
			{
			   %obj.station = new StaticShape() {
				  scale = "1 1 1";
				  dataBlock = "MobileInvStation";
				  lockCount = "0";
				  homingCount = "0";
				  team = %obj.team;
				  vehicle = %obj;
			   };
			   %obj.station.startFade(0,0,true);
			   %obj.mountObject(%obj.station, 2);
			   %obj.station.getDataBlock().createTrigger(%obj.station);
			   %obj.station.setSelfPowered();
			   %obj.station.playThread($PowerThread,"Power");
			   %obj.station.playAudio($HumSound,StationHumSound);
			   %obj.station.vehicle = %obj;
			   %obj.turret = new turret() {
				  scale = "1 1 1";
				  dataBlock = "MobileTurretBase";
				  lockCount = "0";
				  homingCount = "0";
				  team = %obj.team;
			   };
			   %obj.turret.setDamageLevel(%obj.getDamageLevel());
			   %obj.mountObject(%obj.turret, 1);
			   %obj.turret.setSelfPowered();
			   %obj.turret.playThread($PowerThread,"Power");
			   %obj.turret.mountImage(MissileBarrelLarge, 0 ,false);

			}
		 }
		 else
		 {
			%obj.station.setSelfPowered();
			%obj.station.playThread($PowerThread,"Power");
			%obj.turret.setSelfPowered();
			%obj.turret.playThread($PowerThread,"Power");
		 }
		 if(%deployMessage $= "" || %force)
		 {
			if(%obj.turret.getTarget() == -1)
			   %obj.turret.setTarget(%obj.turret.target);

			%obj.turret.setThreadDir($DeployThread, true);
			%obj.turret.playThread($DeployThread,"deploy");
			%obj.turret.playAudio($DeploySound, MobileBaseTurretDeploySound);

			%obj.station.notDeployed = 1;
			%obj.setThreadDir($DeployThread, true);
			%obj.playThread($DeployThread,"deploy");
			%obj.playAudio($DeploySound, MobileBaseDeploySound);
			%obj.deployed = 1;
			%obj.deploySchedule = "";
			%obj.disableMove = true;
			%obj.setFrozenState(true);
			if(isObject(%obj.shield))
			   %obj.shield.delete();

			%obj.shield = new forceFieldBare()
			{
			   scale = "1.22 1.8 1.1";
			   dataBlock = "defaultTeamSlowFieldBare";
			   team = %obj.team;
			};
			%obj.shield.open();
			setTargetSensorData(%obj.getTarget(), MPBDeployedSensor);
		 }
	  if(%deployMessage !$= "")
		 messageClient(%player.client, '', %deployMessage);

	  return true;
   }
   else
   {
	  return false;
   }
}

function TACMobileBaseVehicle::onEndSequence(%data, %obj, %thread)
{
   if(!isObject(%obj))
      return;

   if(%thread == $DeployThread && !%obj.deployed)
   {
      %obj.unmountObject(%obj.station);

      if(isObject(%obj.station))
      {
      		%obj.station.trigger.delete();
      		%obj.station.delete();
      		%obj.station = "";
	  }

	  if(isObject(%obj.beacon))
	  	%obj.beacon.delete();

      if(isObject(%obj.turret))
      {
      		%obj.unmountObject(%obj.turret);
      		%obj.turret.delete();
      		%obj.turret = "";
	  }

      if(!%obj.immobilized)
      {
         %obj.disableMove = false;
         %obj.setFrozenState(false);
      }
      setTargetSensorData(%obj.getTarget(), %data.sensorData);
   }
   else
   {
      %obj.station.startFade(0,0,false);
      %obj.station.setThreadDir($DeployThread, true);
      %obj.station.playThread($DeployThread,"deploy");
      %obj.station.playAudio($DeploySound, MobileBaseStationDeploySound);
      %obj.station.goingOut = true;
      %obj.shield.setTransform(%obj.getSlotTransform(3));
      %obj.shield.close();
      %obj.isDeployed = true;
      %obj.noEnemyControl = 1;
   }

   Parent::onEndSequence(%data, %obj, %thread);
}

function MobileInvStation::onEndSequence(%data, %obj, %thread)
{
   if(!%obj.goingOut)
      %obj.startFade(0,0,true);
   else if(isObject(%obj))
   {
      %obj.notDeployed = 0;
      %obj.vehicle.fullyDeployed = 1;
      //%obj.vehicle.teleporter.setThreadDir($ActivateThread, TRUE);
      //%obj.vehicle.teleporter.playThread($ActivateThread,"activate");
      //%obj.vehicle.teleporter.playAudio($ActivateSound, StationTeleportAcitvateSound);
   }
   Parent::onEndSequence(%data, %obj, %thread);
}


function TACMobileBaseVehicle::checkDeploy(%data, %obj)
{
   %mask = $TypeMasks::VehicleObjectType | $TypeMasks::MoveableObjectType |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType |
           $TypeMasks::ItemObjectType | $TypeMasks::PlayerObjectType;// |
           //$TypeMasks::TurretObjectType | //$TypeMasks::StaticTSObjectType |
           //$TypeMasks::InteriorObjectType;

   //%slot 1 = turret   %slot 2 = station
   %height[1] = 0;
   %height[2] = 0;
   %radius[1] = 2.4;
   %radius[2] = 2.4;
   %stationFailed = false;
   %turretFailed = false;

   for(%x = 1; %x < 3; %x++)
   {
      %posXY = getWords(%obj.getSlotTransform(%x), 0, 1);
      %posZ = (getWord(%obj.getSlotTransform(%x), 2) + %height[%x]);
      InitContainerRadiusSearch(%posXY @ " " @ %posZ, %radius[%x], %mask);

      while ((%objFound = ContainerSearchNext()) != 0)
      {
         if(%objFound != %obj)
         {
            if(%x == 1)
               %turretFailed = true;
            else
               %stationFailed = true;
            break;
         }
      }
   }

   //If turret, station or both fail the send back the error message...
   if(%turretFailed &&  %stationFailed)
      return "Both Turret and Station are blocked and unable to deploy.";
   if(%turretFailed)
      return "Turret is blocked and unable to deploy.";
   if(%stationFailed)
      return "Station is blocked and unable to deploy.";

   //Check the station for collision with the Terrain
   %mat = %obj.getTransform();
   for(%x = 1; %x < 7; %x+=2)
   {
      %startPos = MatrixMulPoint(%mat, %data.stationPoints[%x]);
      %endPos = MatrixMulPoint(%mat, %data.stationPoints[%x+1]);

      %rayCastObj = containerRayCast(%startPos, %endPos, $TypeMasks::TerrainObjectType, 0);
      if(%rayCastObj)
         return "Station is blocked by terrain and unable to deploy.";
   }

   return "";
}

function TACMobileBaseVehicle::onTrigger(%data, %obj, %trigger, %state)
{
	if(%trigger == 0)
		switch (%state)
		{
			case 0:
				%obj.RepairCheck = false;
				%obj.RepairVehicle(false);
			case 1:
				%obj.RepairCheck = true;
				%obj.RepairVehicle(true, 0.018, 6.5);
		}
}

function TACMobileBaseVehicle::playerDismounted(%data, %obj, %player)
{
	Parent::playerDismounted(%data, %obj, %player);
	%obj.RepairCheck = false;
	%obj.RepairVehicle(false);
	%obj.schedule(500, "deployVehicle", %data, %player);
}

function MobileTurretBase::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   setTargetSensorGroup(%obj.target, %obj.team);
   setTargetNeverVisMask(%obj.target, 0xffffffff);
}

function MobileTurretBase::onDamage(%data, %obj)
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function MobileTurretBase::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %targetObject.getObjectMount();
   if(%vehicle)
      %vehicle.getDataBlock().damageObject(%vehicle, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
}

function MobileTurretBase::onEndSequence(%data, %obj, %thread)
{
   //Used so that the parent wont be called..
}







